package inria.paperoles.customization;

import org.ximtec.igesture.algorithm.AlgorithmException;

import edu.umd.cs.piccolo.PCamera;
import inria.paperoles.gestures.recognition.GeneralizedGestureClass;
import inria.paperoles.ui.GestureBrowser;
import inria.paperoles.ui.GesturePath;
import inria.paperoles.ui.ScoreViewer;

public class ClassifyAsCommand extends GestureManipulationCommand{

	
	public ClassifyAsCommand(GesturePath gesture) {
		super("Classify As", gesture);

	}

	/// i may have to change that... to show a warning first... although the action could be undone so no worries...
/*	public void activate(Object context){
		gesture.assignToGestureClass((GeneralizedGestureClass)context, 0);
		
		gesture.getCanvas().getSyntaxAnalyzer().matchOperations(gesture.getToken());
	}
*/
	
	public void activate(Object context){
		GestureBrowser frame =
			(GestureBrowser)((ScoreViewer)((PCamera)gesture.getRoot().getChild(0)).getComponent()).getTopLevelAncestor();
		
		GeneralizedGestureClass gclass = (GeneralizedGestureClass)context;
		gesture.assignToGestureClass(gclass, 0, false);
		
		if(gclass.getDefinition().isCircled()){
			frame.updateParameterClass(gclass, gesture);
			
			ClassifyAllParametersCommand command= new ClassifyAllParametersCommand(frame.getGesturesContainer());
			command.activate(gclass);
		}
		else {
			frame.updateGestureClass(gclass, gesture);
			
			ClassifyAllCommand command= new ClassifyAllCommand(frame.getGesturesContainer());
			command.activate(gclass);
		}
		//gesture.getCanvas().getSyntaxAnalyzer().matchOperations(gesture.getToken());
	}
	
}
