package inria.paperoles.customization;

import java.io.IOException;
import java.util.HashMap;
import java.util.SortedMap;

import javax.swing.JOptionPane;

import de.sciss.net.OSCClient;
import inria.paperoles.openmusic.OpenMusicClient;
import inria.paperoles.operations.Operation;
import inria.paperoles.ui.GesturePath;
import inria.paperoles.ui.GesturesCanvas;
import inria.paperoles.ui.InteractionSurface;
import inria.paperoles.ui.OutputWindow;
import inria.paperoles.ui.ScopeMenu;

public class SendToOutputCommand extends GestureManipulationCommand{

	OutputWindow outwin;
	GesturePath gesture;
	SortedMap<String, Operation> operations;
	
	public SendToOutputCommand(GesturePath gesture, InteractionSurface surface) {
		super("Send to OM", gesture);
	
		this.outwin = surface.getOutput();
		operations = surface.getOperations();
		
		this.gesture = gesture;
	}

	public void activate(Object context){
		//outwin.printCommand(gesture);
		
    	OpenMusicClient client = null;
    	
    	try{
    		client = new OpenMusicClient(outwin, operations); 		
    		client.sendCommand(gesture);
    	}
    	catch(IOException e){	
    		e.printStackTrace();
    		return;
    		//JOptionPane.showMessageDialog(this, "Unable to open connection with Open Music");
    	}
		
		client.kill();
	}
}
