package inria.paperoles.data;

import inria.paperoles.gestures.recognition.GeneralizedGestureClass;
import inria.paperoles.operations.Operation;
import inria.paperoles.ui.GlobalParameters;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.Hashtable;
import java.util.TreeMap;
import java.util.Vector;

import com.thoughtworks.xstream.XStream;

public class DataHistory extends TreeMap<String, PenDataEntry>{

	public DataHistory(){
		super();
	}
	
	public void addEntry(String file){
		PenDataEntry entry = new PenDataEntry(file);
		
		put(entry.getFileName(), entry);
	}
	
	public boolean contains(String fname){
		return containsKey(fname);
	}
	
	public static DataHistory loadHistory(){
	   	ObjectInputStream objectIn;
	   	DataHistory history = null;
	   	
		try {
			objectIn = new ObjectInputStream(new BufferedInputStream(
					new FileInputStream(GlobalParameters.DATA_FOLDER + "/" + "history.xml")));
			XStream xstream = new XStream();
			
			history = (DataHistory) xstream.fromXML((String)objectIn.readObject());
	    	objectIn.close();
	    	
		} catch (Exception e) {
			return null;
		} 
		
		return history;
	}
	
    public void save() {
    	ObjectOutputStream objectOut;
		try {
			objectOut = new ObjectOutputStream(new BufferedOutputStream(
					new FileOutputStream(GlobalParameters.DATA_FOLDER + "/" + "history.xml")));
			
	    	XStream xstream = new XStream();
			objectOut.writeObject(xstream.toXML(this));
	    	objectOut.close(); 
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}
