package inria.paperoles.gestures;

import inria.paperoles.grammar.Token;

import java.awt.geom.Point2D;
import java.awt.geom.Rectangle2D;
import java.util.Collection;

public class ArrowStroke extends ComplexInkStroke{

	public ArrowStroke(SingleInkStroke tail, SingleInkStroke head) {
		super(tail);
		
		addStroke(head);
	}
	
	Point2D headPoint;
	public void setHeadPoint(Point2D p){
		headPoint = p;
	}
	
	public Point2D getHeadPoint(){
		return headPoint;
	}

	public SingleInkStroke getTail(){
		return strokes.elementAt(0);
	}
	
	public SingleInkStroke getHead(){
		return strokes.elementAt(1);
	}
	
	public boolean startsFrom(GeneralInkStroke stroke){
		if(stroke == getTail() || stroke == getHead()) return false;
		return (stroke.getBounds().intersects(
				new Rectangle2D.Double(getTail().getStart().getX()-3, getTail().getStart().getY()-3, 6, 6)));
		
//		return (stroke.getBounds().contains(getStart().x, getStart().y));
	}
	
	public boolean endsTo(GeneralInkStroke stroke){
		if(stroke == getTail() || stroke == getHead()) return false;
		return (stroke.getBounds().intersects(
				new Rectangle2D.Double(headPoint.getX()-3, headPoint.getY()-3, 6, 6)));
		//return (stroke.getBounds().contains(getEnd().x, getEnd().y));
	}
	
	public boolean startsAbout(GeneralInkStroke stroke){
		if(stroke == getTail() || stroke == getHead()) return false;
		return (stroke.getBounds().intersects(
				new Rectangle2D.Double(getTail().getStart().getX()-8, getTail().getStart().getY()-8, 16, 16)));
		
	}
	
	public boolean endsAbout(GeneralInkStroke stroke){
		if(stroke == getTail() || stroke == getHead()) return false;
		return (stroke.getBounds().intersects(
				new Rectangle2D.Double(headPoint.getX()-10, headPoint.getY()-10, 20, 20)));
		//return (stroke.getBounds().contains(getEnd().x, getEnd().y));
	}
	
}
