package inria.paperoles.gestures.definition;

import inria.paperoles.operations.Operation;

import java.awt.Image;

import javax.swing.Icon;
import javax.swing.ImageIcon;

import org.ximtec.igesture.core.DefaultDataObject;

public class GestureDefinition extends DefaultDataObject{
	ImageIcon thumbnail;
	Icon smallthumbnail;
	String name;
	private int type; 
//	Operation operation;

	String operation; 
	
	boolean isCommand = true;
	boolean isCircled = false;
	
	String descr;
	
	Object tokenType;
	
	public GestureDefinition(String name, String descr,  ImageIcon thumbnail, ImageIcon thumbnail2, int type, boolean isCircled){
		this.thumbnail = thumbnail;
		this.name = name;
		this.smallthumbnail = thumbnail2;
		this.type = type;
		this.isCircled = isCircled;
		
		this.descr = descr;
	}
	
	
	public GestureDefinition(String name, String descr, ImageIcon thumbnail, ImageIcon thumbnail2, 
			Operation operation, int type, boolean isCommand, boolean isCircled){
		
		if(operation!=null) this.operation = operation.getName();
		
		this.thumbnail = thumbnail;
		this.name = name;
		this.smallthumbnail = thumbnail2;
		this.type = type;
		this.isCommand = isCommand;
		this.isCircled = isCircled;
		
		this.descr = descr;
	}
	
	
	public GestureDefinition(String name, String descr, ImageIcon thumbnail, ImageIcon thumbnail2, 
			Operation operation, int type, boolean isCommand, boolean isCircled, 
			Object tokenType){
		
		this(name, descr, thumbnail, thumbnail2, operation, type, isCommand, isCircled);
		
		this.tokenType = tokenType;
	}
	
	public Object getTokenType(){
		return tokenType;
	}
	
	public boolean isCircled(){
		return isCircled;
	}
	
	public void setOperation(Operation operation){
		if(operation == null) this.operation = null;
		else this.operation = operation.getName();
	}
	
	public void setOperationName(String operName){
		this.operation = operName;
	}
	
	public String getOperation(){
		return operation;
	}
	
	public ImageIcon getImage(){
		return thumbnail;
	}
	
	public Icon getIcon(){
		return smallthumbnail;
	}
	
	public String getName(){
		return name;
	}
	
	
	public String getDescription(){
		return descr;
	}
	
	public void setDescription(String descr){
		this.descr = descr;
	}
	
	public void setName(String name){
		this.name = name;
	}
	
	public int getType(){
		return type;
	}
	
	public boolean isParameter(){
		return !isCommand;
	}
}


