package inria.paperoles.gestureslearn;

import java.awt.Canvas;
import java.awt.Graphics;

import java.awt.Rectangle;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.util.ArrayList;
import java.util.List;
import java.util.Vector;

import javax.swing.JFrame;
import javax.swing.JPanel;

import org.sigtec.ink.Point;

import papertoolkit.pen.PenSample;

import inria.paperoles.gestures.StrokeRecognizer;
import inria.paperoles.gestures.StrokeRecognizer.Pt;

public class GestureCanvas extends Canvas implements MouseMotionListener, KeyListener{

	Vector<Point> points;
	JFrame frame;
	
	public GestureCanvas(JFrame frame){
		addMouseMotionListener(this);
		addKeyListener(this);
		
		this.frame = frame;
		points = new Vector<Point>();
	}

	Point lastMousePos;
	public void mouseDragged(MouseEvent e) {
//		Point p = e.getPoint() ;
		Point p = new Point(e.getX(), e.getY(), e.getWhen());
		
		getGraphics().drawLine((int)lastMousePos.x, (int)lastMousePos.y, (int)p.x, (int)p.y) ;
		lastMousePos = p ;
		
		points.add(p);
	}

	public void mouseMoved(MouseEvent e) {
		lastMousePos = new Point(e.getX(), e.getY(), e.getWhen());
	}

	public void keyPressed(KeyEvent e) { 
		switch(e.getKeyCode()){
			case KeyEvent.VK_S:
				saveGesture(); 
				break;
			case KeyEvent.VK_C:
				clearCanvas();
				break;
			case KeyEvent.VK_T:
				visualizeGesture();
				break;				
		}
	}

	private void visualizeGesture() {
		final ArrayList<Pt> pointlist = new ArrayList<Pt>();
		for (Point p: points) {
			pointlist.add(new Pt(p.x, p.y));
		}
		
		Rectangle rect = new Rectangle();
		
		final ArrayList<Pt> pts = StrokeRecognizer.transformGesture(pointlist, rect);
		final Rectangle bounds = rect;
		
		JFrame frame = new JFrame("Shape to be recognized");
		Canvas canvas = new Canvas(){
			public void paint(Graphics g){
				g.setColor(java.awt.Color.blue);
				
				for(Pt p: pts){	
					g.drawLine(p.getX() - bounds.x, p.getY()- bounds.y, 
							p.getX() - bounds.x + 2, p.getY()- bounds.y +2);
				}
			}
		};
		
		canvas.setBounds(0, 0, bounds.width, bounds.height);
		frame.getContentPane().add(canvas);
		
		frame.pack();
		frame.setVisible(true);
		
		points = new Vector<Point>(); 
	}

	private void clearCanvas() {
		this.getGraphics().clearRect(0, 0, getWidth(), getHeight());
		
	}

	private void saveGesture() { 
		GestureDialog dialog = new GestureDialog(frame, points);
		dialog.pack();
		dialog.setVisible(true);
		
		//////////////
		points = new Vector<Point>(); 
	}

	public void keyReleased(KeyEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	public void keyTyped(KeyEvent arg0) {
		// TODO Auto-generated method stub
	}
		
}
