package inria.paperoles.grammar;

import java.util.Set;
import java.util.TreeMap;
import java.util.TreeSet;

public class AlternativeScopes extends TreeMap<Scope, AltScope>{
	
	TreeSet<Integer> types;
	
	public AlternativeScopes(){
		super();
		
		types = new TreeSet<Integer>();
	}
	
	public void addScope(Scope scope, int type){
			
		if(containsKey(scope)) get(scope).add(type);
		else put(scope, new AltScope(type));
		
		types.add(new Integer(type));
	}
	
	public Scope getScope(int type){
		Set<Scope> keySet = keySet();
	
		for(Scope scope:keySet){
			if(get(scope) == null) continue;
			if(get(scope).contains(new Integer(type))) return scope;
		}
		
		return null;
	}
	
	public Set<Scope> getScopes(){
		return keySet();
	}
	
	public boolean contains(int type){
		return types.contains(new Integer(type));
	}
	
	public int[] getTypes(Scope scope){//TODO: there is a problem here...
		AltScope altscope = get(scope); 

		if(altscope == null){
			int types[] = new int[1];
			types[0] = scope.getType();
			
			return types;
		}
		
		int types[] = new int[altscope.size()];
		int i = 0;
		for(Integer integer:altscope){
			types[i++] = integer.intValue();
		}
		
		return types;
	}


}
