package inria.paperoles.grammar;

import java.awt.geom.Area;
import java.util.Collection;
import java.util.Vector;

import inria.paperoles.docmodel.Symbol;
import inria.paperoles.scoremodel.Chord;
import inria.paperoles.scoremodel.Note;
import inria.paperoles.scoremodel.PolyStaff;
import inria.paperoles.scoremodel.ScorePart;
import inria.paperoles.ui.GesturesCanvas;

public class ChordsScope extends PrintedScope{

	Collection<Symbol> symbols;
	
	public ChordsScope(GesturesCanvas canvas, PolyStaff pstaff, ScorePart[] scoreParts, int type) {
		super(canvas, pstaff, type);
		// TODO Auto-generated constructor stub
		shape = new Area(scoreParts[0].getBounds());
		((Area)shape).add(new Area(scoreParts[1].getBounds()));
		
		symbols = new Vector<Symbol>();
		
		for(int i=0; i<2; ++i){
			symbols.add(((Chord)scoreParts[i]).firstNote());
//			for(Note note:((Chord)scoreParts[i]).getNotes())
//				symbols.add(note);
		}
		
	}

	
	public ChordsScope(GesturesCanvas canvas, PolyStaff pstaff, ScorePart scorePart, int type) {
		super(canvas, pstaff,  type);
		// TODO Auto-generated constructor stub
		shape = new Area(scorePart.getBounds());
		
		symbols = new Vector<Symbol>();
		for(Note note:((Chord)scorePart).getNotes())
			symbols.add(note);
	}
	

	public Collection<Symbol> getSymbols(){
		return symbols;
	}
	
	public void setActive(boolean active){
		for(Symbol symbol:symbols){
			if(active) symbol.setPaint(java.awt.Color.red);
			else symbol.setPaint(null);
		}
	}
	
	
	public boolean equals(Object o){
		if(!(o instanceof ChordsScope)) return false;
		
		if(this == o || ((ChordsScope)o).shape.getBounds().equals(shape.getBounds())) return true;
		else return false;
	}
}
