package inria.paperoles.grammar;

import inria.paperoles.operations.Operation;
import inria.paperoles.operations.OperationArgument;

import java.util.Collection;
import java.util.Enumeration;
import java.util.HashSet;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Set;
import java.util.TreeSet;
import java.util.Vector;

public class Connections extends TreeSet<Connection>{
	
	Token source;
	public Connections(Token source){
		super();
		
		this.source = source;
	}
	
	public void addConnection(Connection connection){
		add(connection);
	}

	public void removeConnection(Connection connection){
		remove(connection);
	}
	
	public String toString(){
		String str = "";
		for(Connection con:this){
			str+= con.toString() + "\n";
		}
		
		return str;
	}
		
	
	Collection<Token> getConnectedTokens(){
		Set<Token> set = new HashSet<Token>();
		
		for(Connection connection:this)
			addSubTokens(set, connection.connected);
		
		return set;
	}
	
	private void addSubTokens(Set<Token> set, Token token){		
		if(set.contains(token) || token == source) return;
		
		set.add(token);
		for(Connection connection:token.connections) addSubTokens(set, connection.connected);
	}
	
}
