package inria.paperoles.grammar;

import inria.paperoles.gestures.ComplexInkStroke;
import inria.paperoles.gestures.GeneralInkStroke;

import java.awt.geom.Line2D;
import java.util.Collection;
import java.util.Vector;

public class Group extends Token{

	Collection<Token> tokens;
	ComplexInkStroke combinedStroke;
	
	public Group(){
		super(null, null);
		
		tokens = new Vector<Token>();
	}

	
	public void addToken(Token token){
		tokens.add(token);
		gcanvases.add(token.getCanvas());
		token.setParent(this);
	}

	public boolean isLeaf(){
		return false;
	}
	
	public Collection<Token> getSubTokens(){
		return tokens;
	}
	
	public boolean intersects(Line2D line) {
		return false;
	}
	
	public GeneralInkStroke combineStroke(){
		if(combinedStroke == null){
			combinedStroke = new ComplexInkStroke();
		
			for(Token token: tokens)
				combinedStroke.addStroke(token.stroke);
		}
		
		return combinedStroke;
	}
}
