package inria.paperoles.grammar;

import inria.paperoles.gestures.GeneralInkStroke;
import inria.paperoles.ui.GesturesCanvas;

public class LineDelimiter extends ScopeDelimiter {

	public LineDelimiter(GeneralInkStroke stroke, GesturesCanvas gcanvas) {
		super(stroke, gcanvas);
	
		types = new int[1];
		types[0] = Scope.POINTER;
		detectScope();
	}
	
	public LineDelimiter(GeneralInkStroke stroke, GesturesCanvas gcanvas, boolean outOfScore) {
		super(stroke, gcanvas, outOfScore);
		
		if(!outOfScore){
			types = new int[1];
			types[0] = Scope.POINTER;
			detectScope();
		}
	}

	
	public Scope getScope(int type){
		if(type == Scope.POINTER) return scorePointer;
		else return null;
	}
}
