package inria.paperoles.openmusic;

import java.io.IOException;
import java.net.SocketAddress;

import de.sciss.net.OSCChannel;
import de.sciss.net.OSCListener;
import de.sciss.net.OSCMessage;
import de.sciss.net.OSCServer;

public class OMServerSimulation implements OSCListener  {
	final static String PROTOCOL =OSCChannel.UDP;
//	final static int PORT = 1968;
	
	final static int PORT = 5103;
	
	OSCServer server = null;
	
	public OMServerSimulation(){		
		try{
			server = OSCServer.newUsing(PROTOCOL, PORT, true);
		}
		catch( IOException e) {
			e.printStackTrace();
			return;
		}
		
		server.addOSCListener(this);
	
		try {
			server.start();
			server.dumpOSC( OSCChannel.kDumpBoth, System.err );

		} catch (IOException e) {
			e.printStackTrace();
		}
		
		Object sync = new Object();
		try {
			server.start();
			System.err.println("started...");
			try {
				synchronized(sync) {
					sync.wait();
				}
			}
			catch( InterruptedException e1 ) {}
			System.err.println("to be stopped...");
			server.stop();
		 }
		catch( IOException e1 ) {
			e1.printStackTrace();
			server.dispose();
		}
	}
	
	public void messageReceived(OSCMessage message, SocketAddress sender, long time) {
		System.err.println("Sent by " + sender + "\n");
		
		System.err.print(message.getName() + " ");
		
		for(int i = 0; i< message.getArgCount(); ++i)
			System.err.print(message.getArg(i) + " ");
		
		System.err.print("\n");
	}
	
	private void sendOKAnswer(SocketAddress address){
		try {
			server.send(new OSCMessage( "/done"), address);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	public void kill(){
		server.dispose();
	}
	
	public static void main(String[] args){
		new OMServerSimulation();
	}
	
	protected void finalize(){
		kill();
	}
}
