package inria.paperoles.operations;

import java.util.Collection;
import java.util.Hashtable;
import java.util.Vector;

import inria.paperoles.docmodel.Symbol;
import inria.paperoles.grammar.GroupingGesture;
import inria.paperoles.grammar.PrintedScope;
import inria.paperoles.grammar.ScopeDelimiter;
import inria.paperoles.grammar.Token;
import inria.paperoles.scoremodel.Chord;
import inria.paperoles.scoremodel.Note;
import inria.paperoles.scoremodel.ScorePart;

public class MatchedOperation implements Comparable{

	Operation operation;
	Token token;
	
	Hashtable<OperationArgument, Collection<Token>> matchings;
	
	public MatchedOperation(Operation operation, Token token){
		this.operation = operation;
		this.token = token;
		
		matchings = new Hashtable<OperationArgument, Collection<Token>>();
	}
	
	public void addMatching(OperationArgument arg, Collection<Token> matching){
		matchings.put(arg, matching);
	}
	
	public Hashtable<OperationArgument, Collection<Token>> getMatchings(){ 
		return matchings;
	}
	
	public Token getMainToken(){
		return token;
	}
	
	public Operation getOperation(){
		return operation;
	}
	
	
	public String getOperationName(){
		return "/" + operation.getName().toLowerCase();
	}

	@Override
	public int compareTo(Object o) {
		if(!(o instanceof MatchedOperation)) return -1;
		
		MatchedOperation mo2 = (MatchedOperation)o;
		return token.compareScorePositionWith(mo2.token);
	}
	
}
