package inria.paperoles.operations;

import java.util.Collection;
import java.util.SortedSet;
import java.util.TreeSet;
import java.util.Vector;

import org.ximtec.igesture.core.DefaultDataObject;

public class Operation extends DefaultDataObject{
/*
	public final static int SCORE_SCOPE = 0;
	public final static int SCORE_POINTER = 1;
	public final static int TEXT_PARAMETER = 2;
	public final static int WAVE = 3;
	public final static int WAVE_POINT = 4;
	//public final static int RANGE = 4;
	public final static int VOID = 5;
*/
	
	public final static int POINTS = 0;
	public final static int XRANGE = 1;
	public final static int START = 2;
	public final static int CENTER = 3;
	public final static int PARAMETER = 4;
	//public final static int GEST = 5;

	String name;
	Vector<OperationArgument> arguments;
	
	int returnType = CENTER;
	
	public Operation(String name){
		this.name = name.toLowerCase();
		
		arguments = new Vector<OperationArgument>();
	}
	
	public Operation(){		
		arguments = new Vector<OperationArgument>();
	}
	
	
	public Operation(Operation operation){	
		this(operation.name);
		
		for(OperationArgument argument:operation.arguments)
			addArgument(new OperationArgument(argument));
	}
	
	public void addArgument(OperationArgument arg){
		arguments.add(arg);
	}
	
	public int getIndexOfArgument(OperationArgument arg){
		return arguments.indexOf(arg);
	}
	
	public void addArgument(OperationArgument arg, int index){
		arguments.add(index, arg);
	}
	
	public Vector<OperationArgument> getArguments(){
		return arguments;
	}
	
	public SortedSet<OperationArgument> getArgumentsForMatching(){
		return new TreeSet<OperationArgument>(arguments);
	}
	
	
	public void setName(String name){
		this.name = name;
	}
	
	public String getName(){
		return name;
	}
	
	public String toString(){
		return name;
	}
	
	public String definition(){
		String str = name + "(";
		
		int i = 0;
		for(OperationArgument argument:arguments){
			if(i!=0) str+=", ";
			
			str += "$" + (++i) + (argument.isRepeated()?"*":""); 
		}
		
		return str + ")";
	}

	public void removeArgument(OperationArgument argument) {
		arguments.remove(argument);
	}

	public int getReturnType(){
		return returnType;
	}
	
	public void setReturnType(int type) {
		this.returnType = type;
	}
	
}
