package inria.paperoles.operations;

import org.ximtec.igesture.core.DefaultDataObject;

public class OperationArgument extends DefaultDataObject implements Comparable<OperationArgument>{

	String parameter_name = "";
	int type = 0;
	
	boolean repeated = false;
	Operation operation;
	
	public OperationArgument(Operation operation){
		this.operation = operation;
	}
	
	public OperationArgument(OperationArgument argument){
		this(argument.operation, argument.parameter_name, argument.type, argument.repeated);
	}
	
	public OperationArgument(Operation operation, int type){
		this.type = type;
		this.operation = operation;
	}
	
	public OperationArgument(Operation operation, String parameter_name, int type){
		this.parameter_name = parameter_name.toLowerCase();
		this.operation = operation;
		this.type = type;
	}
	
	public OperationArgument(Operation operation, String parameter_name, int type, boolean repeated){
		this.parameter_name = parameter_name.toLowerCase();;
		this.type = type;
		
		this.operation = operation;
		this.repeated= repeated;
	}
	
	public void setRepeated(boolean repeated){
		this.repeated = repeated;
	}
	
	public void setType(int type){
		this.type = type;
	}
	
	public void setParameterName(String name){
		parameter_name = name;
	}
	
	public String getParameterName(){
		return parameter_name.toLowerCase();
	}

	
	public boolean isRepeated(){
		return repeated;
	}
	
	public int getType(){
		return type;
	}

	public int getIndex(){
		return operation.getIndexOfArgument(this);
	}
	
	public int compareTo(OperationArgument arg) {
		if(equals(arg)) return 0;
		
		if((parameter_name == "" || parameter_name==null) &&
				(arg.parameter_name != "" && arg.parameter_name!=null) ) return 1;
		else if((arg.parameter_name == "" || arg.parameter_name==null) &&
				(parameter_name != "" && parameter_name!=null) ) return -1;
		else if(getIndex() <= arg.getIndex()) return -1;
		else return 1;
	}
}
