package inria.paperoles.rendering;

import java.awt.BasicStroke;
import java.awt.Graphics2D;
import java.awt.Paint;
import java.awt.Stroke;
import java.awt.Shape;
import java.util.List;

public class RenderingTechnique {

//	public static final Stroke DEFAULT_INK_STROKE = new BasicStroke(1.0f, BasicStroke.CAP_ROUND,
//			BasicStroke.JOIN_ROUND);

	public void render(Graphics2D g2d, final List<Shape> paths, final double widths[],
			Paint fillPaint){
		int i = 0;
		for(Shape path : paths){
			g2d.setStroke(new BasicStroke((float) widths[i++], BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND));			
			g2d.draw(path);

			if(fillPaint != null){
				g2d.setPaint(fillPaint);
				g2d.fill(path);
			}
		}
	}

}
