package inria.paperoles.scoremodel;

import inria.paperoles.gestures.SingleInkStroke;

import java.awt.Color;
import java.awt.geom.Line2D;
import java.awt.geom.Point2D;

import edu.umd.cs.piccolo.nodes.PPath;

public class GestureNote extends Note implements WrittenSymbol{
	
	SingleInkStroke stroke;
	
	final static Color STROKE_COLOR = new Color(30, 30, 30);
	final static Color FOCUS_STROKE_COLOR = new Color(220, 150, 100);
	
	public GestureNote(SingleInkStroke stroke) {
		super();
		
		this.stroke = stroke;
		setStrokePaint(STROKE_COLOR);
		
		setPathTo(stroke.getShape());
	}
	
	public GestureNote(Chord chord, SingleInkStroke stroke) {
		super();
		
		this.stroke = stroke;
		setStrokePaint(STROKE_COLOR);
		
		setPathTo(stroke.getShape());
		
		setChord(chord);
	}
		
	public Object clone(){
		GestureNote  gnote = new GestureNote(stroke);
		return gnote;
	}

	public Point2D getCenter(){
		return new Point2D.Double(getBounds().getCenterX(), getBounds().getCenterY());
	}
		
	public void setSkeleton(Line2D skeleton){
		addChild(new PPath(skeleton));
	}
		
		
//		private boolean selected = false;
	public void setFocus(boolean focus){
		if(focus) setStrokePaint(FOCUS_STROKE_COLOR);
		else setStrokePaint(STROKE_COLOR);
	}


	@Override
	public void removeFromModel() {
		chord.segment.removeChord(chord);
	}
	
	public String toString(){
		return "Music Symbol";	
	}
	
	public String stringRepresentation() {
		return getVoiceLine().getVoice().getID() + " " + segment.getNum() + " "
		+ chord.num + " " + num;
	}
}
