package inria.paperoles.scoremodel;

import java.awt.Color;
import java.awt.geom.Line2D;
import java.util.Vector;

import edu.umd.cs.piccolo.nodes.PPath;


public class Measure extends ScorePart{

	PolyStaff polyStaff;
	final static Color STROKE_COLOR = new Color(200, 200, 170);
	Vector<Segment> segments;

	static int counter = 1;

	int num;
	public Measure(PolyStaff parent, int x1, int x2) {
		super(x1, (int)parent.getY(), x2-x1, (int)parent.getHeight());
			
		/*
		PPath measureLine = new PPath(new Line2D.Double(x2, (int)parent.getY(), x2, (int)parent.getY() + (int)parent.getHeight()));
		measureLine.setStrokePaint(STROKE_COLOR);
		addChild(measureLine);
		*/
		
		polyStaff = parent;
		parent.addMeasure(this);
		segments = new Vector<Segment>();
		
		num = counter++;
	}

	public Measure(){
		super();
		
		num = counter++;
	}
	
	public static void resetCounter(){
		counter = 1;
	}
	
	public int getNum(){
		return num;
	}
	
	public void initialize(PolyStaff parent, int x1, int x2){
		super.setBoundaries(x1, (int)parent.getY(), x2-x1, (int)parent.getHeight());
		
		/*
		PPath measureLine = new PPath(new Line2D.Double(x2, (int)parent.getY(), x2, (int)parent.getY() + (int)parent.getHeight()));
		measureLine.setStrokePaint(STROKE_COLOR);
		addChild(measureLine);
		*/
		polyStaff = parent;
		parent.addMeasure(this);
		segments = new Vector<Segment>();
	}
	
	public ScoreVerticalPointer getStartPointer(){
		return new  ScoreVerticalPointer(polyStaff, getX());
	}
	
	public ScoreVerticalPointer getEndPointer(){
		return new  ScoreVerticalPointer(polyStaff, getX() + getWidth());
	}
	
	public int compareWith(Measure measure){
		if(this == measure) return 0;
		
		int compare = polyStaff.compareWith(measure.polyStaff);
		if(compare != 0) return compare;
		
		if(polyStaff.measures.indexOf(this) < polyStaff.measures.indexOf(measure)) return -1;
		else return 1;
	}
	
	public Measure getNextMeasure(){
		if(this == polyStaff.getLastMeasure()){
			PolyStaff nextPolyStaff = polyStaff.getNext();
			if(nextPolyStaff == null) return null;
			else return nextPolyStaff.getFirstMeasure();
		}
		else return polyStaff.measures.get(polyStaff.measures.indexOf(this) + 1);
	}
	
	public Measure getPreviousMeasure(){
		if(this == polyStaff.getFirstMeasure()){
			PolyStaff previousPolyStaff = polyStaff.getPrevious();
			if(previousPolyStaff == null) return null;
			else return previousPolyStaff.getLastMeasure();
		}
		else return polyStaff.measures.get(polyStaff.measures.indexOf(this) - 1);
	}
	
	public PolyStaff getPolyStaff(){
		return polyStaff;
	}

	public void addSegment(Segment segment) {
		segments.add(segment);
	}

	public Segment getFirstSegment(){
		return segments.get(0);
	}
	
	public Segment getSegment(Voice voice){
		return segments.get(voice.id -1);
	}

}
