package inria.paperoles.scoremodel;

import java.awt.Shape;
import java.awt.geom.Point2D;

import edu.umd.cs.piccolo.PNode;
import edu.umd.cs.piccolo.util.PBounds;

import inria.paperoles.docmodel.DocPart;
import inria.paperoles.ui.GesturesCanvas;

public class ScorePart extends DocPart {

	final static double DIMENSIONS_EXTENSION = 0;
	
	public ScorePart(int x, int y, int width, int height) {
		super(x, y, width, height);
	}
	
	public ScorePart() {
		super();
	}

	public GesturesCanvas getCanvas(){
		
		PNode parent = getParent();
		for(; !(parent instanceof ScoreSkeleton);
			parent = parent.getParent());
		
		return ((ScoreSkeleton)parent).getCanvas();
	}
	
	public Point2D getCenter(){
		PBounds bounds = getBounds();
		Point2D.Double center = new Point2D.Double(bounds.getCenterX(), bounds.getCenterY());
		
		return center;
	}
	
	public double getMinX(){
		return getBounds().getMinX();
	}
	
	public double getMaxX(){
		return getBounds().getMaxX();
	}
	
	public double getMinY(){
		return getBounds().getMinY() - DIMENSIONS_EXTENSION;
	}
	
	public double getMaxY(){
		return getBounds().getMaxY() + DIMENSIONS_EXTENSION;
	}	
	
	public double getMaxWidth(){
		return getWidth();
	}
	
	public double getMaxHeight(){
		return getHeight() + 2*DIMENSIONS_EXTENSION;
	}

	public Shape getPointerShape() {
		return getBounds();
	}
	
//	public 

}
