package inria.paperoles.scoremodel;

import java.awt.Color;
import java.awt.geom.Line2D;
import java.util.Vector;

import edu.umd.cs.piccolo.nodes.PPath;

public class Segment extends ScorePart{

	Measure measure;
	VoiceLine voiceLine;
	//Vector<Note> notes;
	Vector<Chord> chords;
	
	public Segment(){
		super();
		
	//	notes = new Vector<Note>();
		
		chords = new Vector<Chord>();
	}
	
	public Segment(Measure measure, VoiceLine voiceLine) {
		super((int)measure.getX(), (int)voiceLine.getY(), (int)measure.getWidth(), (int)voiceLine.getHeight());
		
		this.measure = measure;
		this.voiceLine = voiceLine;
		
		measure.addSegment(this);
		voiceLine.addSegment(this);

	//	notes = new Vector<Note>();
	}

	public void initialize(Measure measure, VoiceLine voiceLine, int x, int y, int w, int h){
		super.setBoundaries(x, y, w, h);
		
		this.measure = measure;
		this.voiceLine = voiceLine;
		
		measure.addSegment(this);
		voiceLine.addSegment(this);
		
		setStrokePaint(Color.red);
	}
	
	public Measure getMeasure(){
		return measure;
	}
	
	public VoiceLine getVoiceLine(){
		return voiceLine;
	}

/*	public void addNote(Note note){
		notes.add(note);
	}
*/	
	public int getNum(){
		return measure.getNum();
	}
	
	public void addChord(Chord chord){
		chords.add(chord);
	}
	
	public void removeChord(Chord chord){
		chords.remove(chord);
	}
	
	public Vector<Note> getNotes(){
		Vector<Note> notes = new Vector<Note>();
		for(Chord chord:chords)
			notes.addAll(chord.notes);
		
		return notes;
	}
	
	public String toString(){
		return getVoiceLine().getVoice().getID() + " " + getNum();
	}

	public Vector<Chord> getChords() {
		return chords;
	}	
	
}
