package inria.paperoles.tabletsupport;

import java.util.Vector;

public class DrawnStroke {

	Vector<DrawnPoint> points;
	
	float minX = 100000, maxX = 0, minY = 10000, maxY = 0;
	String colorRGB = "41_0_139";
	
	public DrawnStroke(){
		points = new Vector<DrawnPoint>();
	}
	
	public DrawnStroke(float x, float y){
		this();
		
		addPoint(x, y);
	}
	
	public boolean isEmpty(){
		return points.isEmpty();
	}
	
	public void addPoint(float x, float y){
		points.addElement(new DrawnPoint(x, y));
		
		minX = Math.min(x, minX);
		minY = Math.min(y, minY);
		
		maxX = Math.max(x, maxX);
		maxY = Math.max(y, maxY);
	}
	
	public long getStartTime(){
		return points.firstElement().time;
	}
	
	public long getEndTime(){
		return points.lastElement().time;
	}
	
	public long getDuration(){
		return points.lastElement().time - points.firstElement().time;
	}
	
	public String toString(){
		String str =  "<stroke begin=\"" + getStartTime() + "\" beginSystemTime=\"" + getStartTime() + "\" duration=\"" + getDuration()
		+ "\" end=\"" + getEndTime() + "\" colorRGB=\"" + colorRGB + "\" minStrokeX=\"" + minX + "\" minStrokeY=\"" + minY + "\" maxStrokeX=\"" + maxX + "\" maxStrokeY=\"" + maxY + "\">" ;
		
		for(DrawnPoint p:points)
			str+=p.toString();
		
		str+= "</stroke>";
		
		return str;
	}
	
}
