package inria.paperoles.tabletsupport;

import java.text.DateFormat;
import java.text.DecimalFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.Locale;
import java.util.Vector;

public class DrawnStrokes {
	Vector<DrawnStroke> strokes;
	float minX = 100000, maxX = 0, minY = 100000, maxY = 0;
	
	Date date = null;
	
	public DrawnStrokes(){
		strokes = new Vector<DrawnStroke>();
	}

	public void addStroke(DrawnStroke stroke){
		strokes.addElement(stroke);
		
		minX = (float)Math.floor(Math.min(stroke.minX, minX));
		minY = (float)Math.floor(Math.min(stroke.minY, minY));
		maxX = (float)Math.ceil(Math.max(stroke.maxX, maxX));
		maxY = (float)Math.ceil(Math.max(stroke.maxY, maxY));
	}
	
	public boolean isEmpty(){
		return strokes.isEmpty();
	}
	
	public String getFileName(){
		Calendar calendar = Calendar.getInstance();
		date = calendar.getTime();
		//String ltime = DateFormat.getDateTimeInstance(DateFormat.SHORT, DateFormat.MEDIUM, Locale.FRANCE).format(date);
		DecimalFormat formatter = new DecimalFormat("00");
		
		String filename = formatter.format(calendar.get(Calendar.YEAR))
			+ "_" +  formatter.format((calendar.get(Calendar.MONTH) + 1)) + "_" 
			+  formatter.format(calendar.get(Calendar.DAY_OF_MONTH)) + "__" 
			+  formatter.format(calendar.get(Calendar.HOUR_OF_DAY)) + "_" 
			+  formatter.format(calendar.get(Calendar.MINUTE)) + "_" + 
			 formatter.format(calendar.get(Calendar.SECOND))  + "_TABLET.xml"; 
		
		return filename;
	}
	
	public String toString(){
	
		if(date == null) return "";
		
	//	String utime = DateFormat.getDateTimeInstance(DateFormat.SHORT, DateFormat.MEDIUM, Locale.ENGLISH).format(date);
		String ltime = DateFormat.getDateTimeInstance(DateFormat.SHORT, DateFormat.MEDIUM, Locale.FRANCE).format(date);
		String utime = ltime;
		
		String str = "<!xml version=\"1.0\"?><penRequest><requestInformation> <universalTime time=\"" + utime + "\"/>"
			+ "<localTime time=\"" + ltime + "\"/><penID id=\"tablet\" /> <numPages num=\"1\" /> </requestInformation><page address=\"1.1.1.1\" addressWithInstance=\"1.1.1.1#0\" segment=\"1\" shelf=\"1\" book=\"1\" page=\"1\" ";
		str += "minX=\"" + (int)minX + "\" minY=\"" + (int)minY + "\" maxX=\"" + (int)maxX + "\" maxY=\"" + (int)maxY + "\">";
		
		for(DrawnStroke stroke:strokes) str+=stroke.toString();
		
		str+= "</page> </penRequest>";
		
		return str;
	}
	
	
//	<?xml version="1.0"?><penRequest><requestInformation><universalTime time="10/07/2008 11:52:17" /><localTime time="10/07/2008 13:52:17" /><penID id="AJ3-AAB-ZJG-N5" /><numPages num="1" /></requestInformation><page address="21.106.18.16" addressWithInstance="21.106.18.16#0" segment="21" shelf="106" book="18" page="16" minX="5" minY="50" maxX="674" maxY="890">
}
