package inria.paperoles.tabletsupport.event;

import java.io.FileWriter;
import java.io.IOException;

import inria.paperoles.tabletsupport.DrawnStroke;
import inria.paperoles.tabletsupport.DrawnStrokes;
import inria.paperoles.ui.DataListWindow;
import inria.paperoles.ui.GlobalParameters;
import inria.paperoles.ui.ScoreViewer;
import edu.umd.cs.piccolo.event.PBasicInputEventHandler;
import edu.umd.cs.piccolo.event.PInputEvent;


public class DrawingListener extends PBasicInputEventHandler{

	DrawnStrokes strokes;
	DataListWindow dataFilesWindow;
	boolean isPortrait = false;
	
	public DrawingListener(DataListWindow dataFilesWindow, boolean isPortrait){		
		strokes = new DrawnStrokes();
		this.dataFilesWindow = dataFilesWindow;
		
		this.isPortrait = isPortrait;
	}
	
	private DrawnStroke stroke;
	public void mousePressed(PInputEvent event){
		ScoreViewer sviewer = (ScoreViewer)event.getComponent();
		
		sviewer.initDraw(event.getPosition());				
		
		stroke = new DrawnStroke();
		
		/*if(isPortrait)
			stroke = new DrawnStroke(/*(float)event.getPosition().getX(), 
					(float)event.getPosition().getY());
		else 
			stroke = new DrawnStroke((float)event.getPosition().getY(), 
					sviewer.getWidth() - (float)event.getPosition().getX());*/
	}
	
	public void mouseReleased(PInputEvent event){
		if(!stroke.isEmpty()) strokes.addStroke(stroke);
	}
	
	public void mouseDragged(PInputEvent event){ 
		ScoreViewer sviewer = (ScoreViewer)event.getComponent();
		float width =  Math.round(sviewer.getWidth()/sviewer.getScale());
	
		sviewer.draw(event.getPosition());		
		
		if(isPortrait)
			stroke.addPoint((float)event.getPosition().getX(), (float)event.getPosition().getY());
		else 
			stroke.addPoint((float)event.getPosition().getY(), width - (float)event.getPosition().getX());
	}
	
	public void end(){
		if(!strokes.isEmpty()){
			String fname = strokes.getFileName();
			String fullname = GlobalParameters.DATA_FOLDER  + fname;
			try {
				FileWriter out = new FileWriter(fullname);
				
				out.write(strokes.toString());
				out.close();	
				
				dataFilesWindow.registerTabletFile(fname);
				dataFilesWindow.dispatchData(fullname);
			} catch (IOException e) {
				// TODO Auto-generated catch block
				//e.printStackTrace();
			}
			
		}
	}
	
}
