package inria.paperoles.ui;

import inria.paperoles.customization.ClassifyAllCommand;
import inria.paperoles.customization.ClassifyAllParametersCommand;
import inria.paperoles.gestures.recognition.GeneralizedGestureClass;

import java.awt.Color;
import java.awt.Font;
import java.awt.geom.Line2D;
import java.awt.geom.Rectangle2D;

import edu.umd.cs.piccolo.PCamera;
import edu.umd.cs.piccolo.event.PBasicInputEventHandler;
import edu.umd.cs.piccolo.event.PInputEvent;
import edu.umd.cs.piccolo.event.PInputEventListener;
import edu.umd.cs.piccolo.nodes.PPath;
import edu.umd.cs.piccolo.nodes.PText;
import edu.umd.cs.piccolo.util.PBounds;

public class AddToSamplesButton extends PPath{
	
	GesturePath parent;
	final static int BOX_SIZE = 8;
	
	PPath line1, line2;
	PPath label;
	
	PPath button;
	PText popLabel;
	
	public AddToSamplesButton(GesturePath parent){
		this.parent = parent;
		
		PBounds bounds = parent.body.getFullBounds();
		
		button = new PPath(new Rectangle2D.Double(bounds.getMaxX() + 2, bounds.getMinY(),
				BOX_SIZE, BOX_SIZE));
		
		line1 = new PPath(new Line2D.Double(bounds.getMaxX() + BOX_SIZE/2 + 2, bounds.getMinY() + 2,
				bounds.getMaxX() + BOX_SIZE/2 + 2, bounds.getMinY() + BOX_SIZE - 2));
		button.addChild(line1);
		
		line2 = new PPath(new Line2D.Double(bounds.getMaxX() + 2 + 2, bounds.getMinY() + BOX_SIZE/2,
				bounds.getMaxX() + BOX_SIZE + 2 - 2, bounds.getMinY() + BOX_SIZE/2));
		button.addChild(line2);
		
		button.setPaint(Color.white);
		focus(Color.blue);
		
		parent.addChild(this);

		label = createLabel(bounds.getMaxX(), bounds.getMinY() - 15);
		addChild(label);
		
		label.setVisible(false);
		
		addChild(button);
		button.addInputEventListener(new PBasicInputEventHandler(){
			public void mouseEntered(PInputEvent event){
				focus(Color.blue.brighter());
				label.setVisible(true);
				button.moveToFront();
			}
			
			public void mouseExited(PInputEvent event){
				focus(Color.blue);
				label.setVisible(false);
			}
			
			public void mouseClicked(PInputEvent event){
				click();
			}
			
			public void mousePressed(PInputEvent event){
				focus(new Color(150, 0, 0));
			}
			
		});
	}

	PPath createLabel(double x, double y){
		Color col = new Color(10, 10, 20);
		
		PPath box = new PPath();
		box.setPaint(Color.white);
		box.setStrokePaint(col);
		
		popLabel = new PText("add sample to \"" + parent.getGestureClass().getDefinition().getName() + "\" class");
		popLabel.setFont(new Font("Arial", Font.PLAIN, 10));
		addChild(popLabel);

		box.addChild(popLabel);
		
		box.setPathToRectangle((int)(x - popLabel.getWidth()/2 - 20),
				(int)(y - popLabel.getHeight()/2 - 2), 
				(int)popLabel.getWidth() + 4, (int)popLabel.getHeight() + 4);
		
		popLabel.setX(box.getBounds().getX() + 4);
		popLabel.setY(box.getBounds().getY() + 3);
		popLabel.setTextPaint(col);
		
		return box;
	}
	
	void focus(Color color){
		button.setStrokePaint(color);
		line1.setStrokePaint(color);
		line2.setStrokePaint(color);

	}
	
	void click(){
/*		
		parent.removeChild(this);
		parent.samplesButton = null;
		
		GestureBrowser frame =
			(GestureBrowser)((ScoreViewer)((PCamera)parent.getRoot().getChild(0)).getComponent()).getTopLevelAncestor();

		GeneralizedGestureClass gclass = parent.getGestureClass();
		if(gclass.getDefinition().isCircled()){
			frame.updateParameterClass(gclass, parent);

			ClassifyAllParametersCommand command= new ClassifyAllParametersCommand(frame.getGesturesContainer());
			command.activate(gclass);	
		}
		else{ 
			frame.updateGestureClass(gclass, parent);
			
			ClassifyAllCommand command= new ClassifyAllCommand(frame.getGesturesContainer());
			command.activate(gclass);
		}
*/		
	}

	public void update() {
		popLabel.setText("add sample to " + parent.getGestureClass().getDefinition().getName() + " class");
	}	
	
	
	
}
