package inria.paperoles.ui;

import inria.paperoles.data.DataDispatcher;
import inria.paperoles.data.DataHistory;
import inria.paperoles.data.PenDataEntry;
import inria.paperoles.gestures.InkEventHandler;

import java.awt.BorderLayout;
import java.awt.Canvas;
import java.awt.Component;
import java.awt.Dimension;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.URL;
import java.net.URLConnection;
import java.util.SortedSet;
import java.util.TreeSet;
import java.util.Vector;

import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JScrollPane;
import javax.swing.JToolBar;

import edu.umd.cs.piccolo.PCanvas;

import papertoolkit.pen.synch.BatchedDataDispatcher;

public class CurvesWindow extends JDialog{
	
	final static int NORMAL_WIDTH = 850;
	final static int NORMAL_HEIGHT = 650;
	
	/*
	public CurvesWindow(JFrame parent, PCanvas viewer, int x, int y){
		super(parent, "Graph Paper");
		setBounds(x, y, NORMAL_WIDTH, NORMAL_HEIGHT);

		if(viewer == null)
			viewer = new PCanvas();		
		
		JScrollPane scrollPane = new JScrollPane(viewer, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
	    getContentPane().add(scrollPane);
	    
		setVisible(true);
	}*/
 
	
	public CurvesWindow(JFrame parent, ScoreViewer viewer, int x, int y){
		super(parent, "Graph Paper");
		setBounds(x, y, NORMAL_WIDTH, NORMAL_HEIGHT);

//		if(viewer == null)
//			viewer = new PCanvas();		
		
		JScrollPane scrollPane = new JScrollPane(viewer, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
	
		InteractionSurface interactionSurface = new InteractionSurface(scrollPane, (GestureBrowser)parent);		
		viewer.gesturesCanvas.eventHandler.setInteractionSurface(interactionSurface);
		
		getContentPane().add(interactionSurface);
	    				
		setVisible(true);
	}


}
