package inria.paperoles.ui;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.awt.RenderingHints;
import java.awt.Shape;
import java.awt.geom.AffineTransform;
import java.util.ArrayList;
import java.util.List;

import papertoolkit.paper.Region;
import papertoolkit.tools.design.swing.RegionComponent;

public class DrawingSurface extends RegionComponent{

	static DrawingSurface activeSurface = null;
	
	public DrawingSurface(Region r) {
		super(r);
	}
	
	private List<Shape> inks = new ArrayList<Shape>();
	
	protected void add(Shape s) {
		activeSurface = this;
		
		synchronized (inks) {
			AffineTransform transform = AffineTransform.getScaleInstance(1/getRegion().getScaleX(), 1/getRegion().getScaleY());
			transform.translate(dx, dy);
			
/*			AffineTransform transform = AffineTransform.getTranslateInstance(dx, dy);
			transform.scale(1/getRegion().getScaleX(), 1/getRegion().getScaleY());
*/			
			inks.add(transform.createTransformedShape(s));
		}
		Rectangle r = s.getBounds();
		repaint(r.x - 1, r.y - 1, r.width + 4, r.height + 4);
		// repaint();
	}
	
	static DrawingSurface getActiveSurface(){
		return activeSurface;
	}
	
	static double dx, dy;
	public static void setGlobalScrolling(double x, double y){
		dx = x;
		dy = y;
	}
	
	public void cleanAll(){
		inks.clear();
	}
	
	/**
	 * Draws strokes
	 */
	protected void paintComponent(Graphics g) { 
	
		super.paintComponent(g);
		Graphics2D g2d = (Graphics2D) g;
		
		if(getBackground() != null){
			g2d.setPaint(getBackground());
			g2d.fillRect(0, 0, getWidth(), getHeight());
		}
		
		//if(getForeground() != null) 
		g2d.setColor(getForeground());
		
		g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);

		g2d.translate(-dx, -dy);
		g2d.scale(getRegion().getScaleX(), getRegion().getScaleY());	

//System.err.println("...."+dy);		
		synchronized (inks) {
			for (Shape s : inks) { 
				g2d.draw(s);
			}	
		}		
		g2d.scale(1,1);
		g2d.translate(dx, dy);
		
	}

}
