package inria.paperoles.ui;

import inria.paperoles.customization.ClassifyAllCommand;
import inria.paperoles.customization.ClassifyAllParametersCommand;
import inria.paperoles.gestures.definition.SimpleGestureDefinition;
import inria.paperoles.gestures.recognition.GeneralizedGestureClass;
import inria.paperoles.grammar.BlockToken;
import inria.paperoles.grammar.GroupingGesture;
import inria.paperoles.grammar.ParenthesizedToken;
import inria.paperoles.grammar.Scope;
import inria.paperoles.operations.Operation;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.util.Collection;
import java.util.Enumeration;

import javax.swing.*;
import javax.swing.border.Border;

public class GestureDefinitionDialog extends JDialog{

	GesturePath gesture;
	GeneralizedGestureClass gclass;
	
	GestureBrowser gestureBrowser;
	
//	final static String COMMAND_DEFINITION = "Command";
//	final static String PARAMETER_DEFINITION = "Constant";
	
	Border border = BorderFactory.createEmptyBorder(5, 5, 5, 5);
	
	public GestureDefinitionDialog(GestureBrowser parentFrame, GeneralizedGestureClass gclass, GesturePath gesture, int x, int y){
		super(parentFrame, "Define Gesture", true);
		
		this.gclass = gclass;
		this.gesture = gesture;
		gestureBrowser = parentFrame;
		
		setLocation(x, y);
		
		setLayout(new BorderLayout());
		JPanel generalPanel = createGeneralPanel();
	//	JPanel recognitionPanel = createRecognitionPanel(); 
		JPanel bottomPanel = createBottomPanel();
		
	    JTabbedPane tabbedPane = new JTabbedPane();
	    tabbedPane.addTab("General", generalPanel);
	   // tabbedPane.addTab("Recognition", recognitionPanel);
	    //recognitionPanel.setEnabled(false);
	//    tabbedPane.setSize(150, 250);

	    add(tabbedPane, BorderLayout.NORTH);
	    add(bottomPanel, BorderLayout.SOUTH);
	    
	    setResizable(false);
	    pack();
	    
	  /*  if(parameterPanel != null) parameterPanel.name.requestFocusInWindow();
	    else*/ commandPanel.name.requestFocusInWindow();
	}
	
	JButton applyButton;
	private JPanel createBottomPanel() {
		
		JPanel panel = new JPanel();
		panel.setBorder(border);
		
		applyButton = new JButton("Insert");
		if(gclass == null) applyButton.setEnabled(false);
		JButton closeButton = new JButton("Cancel");
	
		//final ClassifyAllCommand command= new ClassifyAllCommand(gestureBrowser.getGesturesContainer());
		
		applyButton.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				if(gesture == null){ 
					gclass.getDefinition().setOperation(commandPanel.getOperation());
					gclass.getDefinition().setName(commandPanel.getName());
					gclass.setName(commandPanel.getName());
					gclass.getDefinition().setDescription(commandPanel.getDescription());
					
					gestureBrowser.getGestureList().updateSelectedGesture();
			
					closeDialog();
					return;
				}
				
				boolean isCommand = true;//commandsButton.isSelected();
				
				if(!(gesture.getToken() instanceof GroupingGesture)){	
					
					SimpleGestureDefinition definition = 
						new SimpleGestureDefinition(commandPanel.getName(), 
							commandPanel.description.getText(),
							gesture.getTumbnail(GlobalParameters.DICTIONARY_ITEM_WIDTH, 
									GlobalParameters.DICTIONARY_ITEM_HEIGHT, !isCommand), 
							gesture.getTumbnail(GlobalParameters.MENU_ITEM_WIDTH, 
										GlobalParameters.MENU_ITEM_HEIGHT, !isCommand),
										isCommand?commandPanel.getOperation():null,
								commandPanel.getScopeType(), isCommand, false,
								gesture.getToken().getClass()
					);
			
					GeneralizedGestureClass gclass = gestureBrowser.addGestureClass(gesture, definition);
				
					if(gclass != null){
						ClassifyAllCommand command= new ClassifyAllCommand(gestureBrowser.getGesturesContainer());
						command.activate(gclass);
					}
				}
				else {///////
					SimpleGestureDefinition definition = 
						new SimpleGestureDefinition(commandPanel.getName(),
							commandPanel.description.getText(),
							gesture.getTumbnail(GlobalParameters.DICTIONARY_ITEM_WIDTH, 
									GlobalParameters.DICTIONARY_ITEM_HEIGHT, !isCommand),
							gesture.getTumbnail(GlobalParameters.MENU_ITEM_WIDTH, 
										GlobalParameters.MENU_ITEM_HEIGHT, !isCommand), 
										isCommand?commandPanel.getOperation():null,
										commandPanel.getScopeType(), isCommand, true
							);
				
					GeneralizedGestureClass gclass = gestureBrowser.addParameterClass(gesture, definition);
					
					if(gclass != null){
						ClassifyAllParametersCommand command= new ClassifyAllParametersCommand(gestureBrowser.getGesturesContainer());
						command.activate(gclass);	
					}
					
				}///////////
				
				closeDialog();
			}
		});
		
		closeButton.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				closeDialog();
			}
		});
		
		panel.add(applyButton);
		panel.add(closeButton);
		
		return panel;
	}

	private void closeDialog(){
		super.dispose();
	}
	
	
	private JPanel createRecognitionPanel() {
		JPanel pane = new JPanel();

		return pane;
	}

	CommandDefinitionPanel commandPanel;
//	JRadioButton commandsButton, parametersButton;
	 
	private JPanel createGeneralPanel() {
		JPanel pane = new JPanel();
		pane.setLayout(new BoxLayout(pane, BoxLayout.Y_AXIS));
        
   //     JPanel definitionType = new JPanel();
       
//        commandsButton = new JRadioButton(COMMAND_DEFINITION);
 //       commandsButton.setActionCommand(COMMAND_DEFINITION);
        
    //    if(gesture.getToken() instanceof BlockToken || gesture.getToken() instanceof ParenthesizedToken)
    //    	commandsButton.setEnabled(false);
        
  //      parametersButton = new JRadioButton(PARAMETER_DEFINITION);
   //     parametersButton.setActionCommand(PARAMETER_DEFINITION);
        
   //    ButtonGroup group = new ButtonGroup();
   //     group.add(commandsButton);
   //     group.add(parametersButton);
 
   //     definitionType.add(commandsButton);
   //     definitionType.add(parametersButton);
        
    //    pane.add(definitionType);
        
        commandPanel = new CommandDefinitionPanel();
        
       ActionListener alistener = new ActionListener(){
    	   public void actionPerformed(ActionEvent e) {  
    	      /*if(e.getSource() == commandsButton)*/ commandPanel.enableOperations(true);
    	      //else commandPanel.enableOperations(false);
    		}
        };
            
 //       commandsButton.addActionListener(alistener);
 //       parametersButton.addActionListener(alistener);
            
 //       commandsButton.setSelected(true);

        pane.add(commandPanel);
        
		return pane;
	}
	
	class ScopeSelection{
		int type;
		String name;
		ScopeSelection(String name, int i){
			this.name = name;
			this.type = i;
		}
		
		public String toString(){
			return name;
		}
	}
	

	/////////////////////////
	class CommandDefinitionPanel extends JPanel{
		JTextField name;
		JComboBox scope;
		JTextArea description;
		JComboBox operation;
		
		CommandDefinitionPanel(){
			setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
			
			//////////////////////////////////////
			JPanel namePanel = new JPanel();
			namePanel.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
			namePanel.setLayout(new BoxLayout(namePanel, BoxLayout.X_AXIS));
			JLabel nameLabel = new JLabel("Name");
			name = new JTextField(10);
			name.addKeyListener(new KeyAdapter(){
				public void keyReleased(KeyEvent e) { 
					if(name.getText().trim().equals("")) applyButton.setEnabled(false);
					else applyButton.setEnabled(true);
				}
			});	
			
			nameLabel.setPreferredSize(new Dimension(80, (int)name.getPreferredSize().getHeight()));	
			
			namePanel.add(nameLabel);
			namePanel.add(name);
			
			/////////////////////////////////////
			JPanel descriptionPanel = new JPanel();
			descriptionPanel.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
			descriptionPanel.setLayout(new BoxLayout(descriptionPanel, BoxLayout.X_AXIS));
			JLabel descriptionLabel = new JLabel("Description");
			description = new JTextArea(4, 10);
			description.setLineWrap(true);
			description.setWrapStyleWord(true);
			JScrollPane scroll = new JScrollPane(description, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
			
			descriptionLabel.setPreferredSize(new Dimension(80, descriptionPanel.getHeight()));
			descriptionPanel.add(descriptionLabel);
			descriptionPanel.add(scroll);
					
			add(namePanel);
			add(descriptionPanel);
			 
			/////////////// To attach operations///
			Collection<Operation> operations = gestureBrowser.functionsBar.list.getOperations();
					
			JPanel operationsPanel = new JPanel();
			operationsPanel.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
			operationsPanel.setLayout(new BoxLayout(operationsPanel, BoxLayout.X_AXIS));
			JLabel operationLabel = new JLabel("Operation");
			operationLabel.setPreferredSize(new Dimension(80, operationLabel.getHeight()));
		
			operation = new JComboBox(operations.toArray());
			operation.insertItemAt("None", 0);
			operation.setSelectedIndex(0);
			operationsPanel.add(operationLabel);
			operationsPanel.add(operation);
			
			add(operationsPanel);
			
			if(gclass!=null){
				name.setText(gclass.getDefinition().getName());
				description.setText(gclass.getDefinition().getDescription());
				
				int i = gestureBrowser.functionsBar.getOperationList().getOperationIndex(gclass.getDefinition().getOperation());
				if(i>=0){
					operation.setSelectedIndex(i+1);
					
					//and update the name of the operation
					gclass.getDefinition().setOperationName(operation.getSelectedItem().toString());
				}
				
			}//TODO
			
			///////////
		/*
			// only if the definition of scope is relevant...
			if(gesture.getToken().getScope() != null){
				int types[] = gesture.getToken().getAlternativeScopes().getTypes(gesture.getToken().getScope());
				
				ScopeSelection scopeOptions[] = new ScopeSelection[types.length];
				for(int i = 0; i<types.length; ++i){
					scopeOptions[i] = new ScopeSelection(Scope.getTypeName(types[i]), types[i]);
				}
			
			
				JPanel scopePanel = new JPanel();
				scopePanel.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
				scopePanel.setLayout(new BoxLayout(scopePanel, BoxLayout.X_AXIS));
				JLabel scopeLabel = new JLabel("Scope");
				scopeLabel.setPreferredSize(new Dimension(80, scopeLabel.getHeight()));
			
				scope = new JComboBox(scopeOptions);
				scopePanel.add(scopeLabel);
				scopePanel.add(scope);
				
				add(scopePanel);
			}
			else*/ add(new JPanel());
			
		}		
		
		public void enableOperations(boolean b) {
			operation.setEnabled(b);
		}

		public Operation getOperation() {
			if(operation.getSelectedItem() instanceof Operation)
				return (Operation)operation.getSelectedItem();
			else return null;
		}

		public String getName(){
			return name.getText().toLowerCase();
		}
		
		public int getScopeType(){
			if(scope == null) return -1;
			return ((ScopeSelection)scope.getSelectedItem()).type;
		}		
		
		public String getDescription(){
			return description.getText();
		}	
		
		public void clean(){
			description.setText("");
			name.setText("");
		}
	}
	

	
}
