package inria.paperoles.ui;

import inria.paperoles.gestures.recognition.GeneralizedGestureClass;
import inria.paperoles.grammar.Token;

import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;
import java.util.Vector;

import edu.umd.cs.piccolo.PCamera;
import edu.umd.cs.piccolo.PNode;

public class GesturesContainer extends Vector<GesturesCanvas>{
	
	
	GestureBrowser browser;
	public GesturesContainer(GestureBrowser browser){
		super();
		
		this.browser = browser;
	}
	
	public Vector<GesturePath> getGestures(){
		Vector<GesturePath> gpaths = new Vector<GesturePath>();
		
		for(GesturesCanvas canvas:this){
			Iterator childIterator = canvas.getChildrenIterator();
			
			while(childIterator.hasNext())
				gpaths.add((GesturePath)childIterator.next());	
		}
		
		return gpaths;
	}
	
	public GestureBrowser getBrowserFrame(){
		return browser;
	}

	
	public void setDistanceThreshold(int value) { 
		for(GesturesCanvas canvas:this)
			canvas.setDistanceThreshold(value);	
	}

	public Set<Token> updateClasses() {
		HashSet<Token> tokens = new HashSet();
		
		for(GesturesCanvas canvas:this){
			Iterator childIterator = canvas.getChildrenIterator();
			GesturePath path;
			
			while(childIterator.hasNext())
				if((path = (GesturePath)childIterator.next()).updateClass()) 
					tokens.add(path.getToken());	
		}
		
		return tokens;
	}

	public void removeGestureClass(GeneralizedGestureClass gestureClass) {
		browser.removeGestureClass(gestureClass);
	}
	
}
