package inria.paperoles.ui;

import java.awt.Color;
import java.awt.Font;
import java.awt.geom.Point2D;
import java.awt.geom.Rectangle2D;

import javax.swing.JLabel;

import inria.paperoles.customization.GestureManipulationCommand;
import inria.paperoles.ui.menus.JMarkingMenuOption;
import edu.umd.cs.piccolo.event.PInputEvent;
import edu.umd.cs.piccolo.nodes.PPath;
import edu.umd.cs.piccolo.nodes.PText;

public class MarkingMenuOption extends PPath{

	GestureManipulationCommand option;
	Object argument;
	boolean active = true;
	
	public MarkingMenuOption(JMarkingMenuOption visualLabel, GestureManipulationCommand option, Object argument, double x, double y) {
		this.option = option;
		this.argument = argument;
		
		setPathTo(new Rectangle2D.Double(x - 2, y - 2, 4, 4));
		
		setPaint(null);
		setStrokePaint(null);
		this.label = visualLabel;
	}
	
	JMarkingMenuOption label;
	/*public void setVisualComponent(JMarkingMenuOption label){
		this.label = label;
	}*/
	
	public GestureManipulationCommand getOption(){	
		return option;
	}
	
	public Point2D getPosition(){
		return getBounds().getCenter2D();
	}

	public Object getArgument(){ 
		if(argument instanceof FlatSubmenu) return null;
		else return argument;
	}
	
	public void loseFocus() {
		if(!active) return;
		if(label!=null) label.loseFocus();
		if(argument != null && argument instanceof FlatSubmenu) {
			((FlatSubmenu)argument).disactivate();
			((MarkingMenu)getParent()).enable();
		}
	}

	
	public void gainFocus() {
		if(!active) return;
		if(label!=null) label.gainFocus();
		if(argument != null && argument instanceof FlatSubmenu){
			((MarkingMenu)getParent()).disable();
			((FlatSubmenu)argument).activate(this);
		}
	}

	public MarkingMenuOption findClosestOption(Point2D p) {
		if(argument != null && argument instanceof FlatSubmenu && active)
			return ((FlatSubmenu)argument).findClosestOption(p);
		else return null;
	}

	public void setInactive() { 
		active = false;
		label.lock();
	}

	public void handleEvent(PInputEvent event) {
		
	}

}
